'use server';
import { NextResponse } from 'next/server';
import { GraphQLClient, gql } from 'graphql-request';
import { addBuildSitesSchema } from './schema';

const endpoint = "http://localhost:3001/graphql";

export async function POST(request: Request) {
    const body = await request.json();
    const validatedBody = addBuildSitesSchema.parse(body);
    console.dir({ validatedBody })
    try {
        const client = new GraphQLClient(endpoint);
        const query = gql`
            mutation CreateBuildSite($input: CreateBuildSitesInput!) {
                createBuildSite(input: $input) {
                    _id
                    siteName
                    siteNo
                    createdAt
                    expiryStarts
                    expiryEnds
                }
            }
        `;
        const variables = { input: validatedBody };
        const data = await client.request(query, variables);
        return NextResponse.json({ data: data.createBuildSite, status: 200 });
    } catch (err: any) {
        console.error(err);
        return NextResponse.json({ error: err.message }, { status: 500 });
    }
}
